Google Images need img-reorder turned off.
[privoxy.git] / privoxy-generic.init
1 #!/bin/sh 
2
3 #  ********************************************************************
4
5 #  File        :  $Source: /cvsroot/ijbswa/current/privoxy-generic.init,v $
6
7 #  Purpose     :  This shell script takes care of starting and stopping
8 #                 privoxy.
9
10 #  Copyright   :  Written by and Copyright (C) 2001,2002 the SourceForge
11 #                 Privoxy team. http://www.privoxy.org/
12
13 #                 Based on the Internet Junkbuster originally written
14 #                 by and Copyright (C) 1997 Anonymous Coders and
15 #                 Junkbusters Corporation.  http://www.junkbusters.com
16
17 #                 This program is free software; you can redistribute it
18 #                 and/or modify it under the terms of the GNU General
19 #                 Public License as published by the Free Software
20 #                 Foundation; either version 2 of the License, or (at
21 #                 your option) any later version.
22
23 #                 This program is distributed in the hope that it will
24 #                 be useful, but WITHOUT ANY WARRANTY; without even the
25 #                 implied warranty of MERCHANTABILITY or FITNESS FOR A
26 #                 PARTICULAR PURPOSE.  See the GNU General Public
27 #                 License for more details.
28
29 #                 The GNU General Public License should be included with
30 #                 this file.  If not, you can view it at
31 #                 http://www.gnu.org/copyleft/gpl.html
32 #                 or write to the Free Software Foundation, Inc., 59
33 #                 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
34 #
35 # Developer's NOTE: This script should be tested against a true /bin/sh, which
36 # has notable differences from bash. By design, this script does not try to do
37 # too much, so as to be as cross-platform as possible.
38 #
39
40 #  Revisions   :
41 #     $Log: privoxy-generic.init,v $
42 #     Revision 1.5.2.1  2002/10/17 17:04:22  hal9
43 #     Add from main trunk. Will be needed for make install.
44 #
45 #     Revision 1.5  2002/10/17 17:01:29  hal9
46 #     Set paths to match the defaults for a root install. Force remove PIDFILE on
47 #     stop.
48 #
49 #     Revision 1.4  2002/09/11 01:15:02  hal9
50 #     Fix typo in variable. Now tested on Solaris and Linux, with defaults.
51 #
52 #     Revision 1.3  2002/09/11 01:09:14  hal9
53 #     Better handling of pidfile, and process owner.
54 #
55 #     Revision 1.2  2002/09/08 20:27:58  hal9
56 #     -Rewrote script config section.
57 #     -Added comments to script.
58 #     -Tried to add logic to use a --user privoxy, if available.
59 #     -Minor script changes due to 'echo -n' does not work on a true
60 #      /bin/sh system.
61 #
62 #     Revision 1.1  2002/09/06 00:20:26  hal9
63 #     Creating a generic init script, meant to be used on platforms where don't have
64 #     a custom init script.
65 #
66 #     Revision 1.0  2002/09/05 17:14:32  hal9
67 #
68 #######################################################################
69
70 # Is this needed by Solaris?
71 #ident  "@(#)privoxy  1.0     02/09/05"
72
73 # NOTE: This script may require editing to ensure proper location of 
74 # config file, and the privoxy executable. Care should be taken to ensure 
75 # logfile is writable by $P_USER (logfile is defined in config), and that 
76 # there is suitable write access for $P_PIDFILE.
77
78 PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin/:/usr/bin:/sbin:/bin
79 P_NAME=Privoxy
80 # Path to executable.
81 P_DAEMON=privoxy
82 # Full path to location of Privoxy config file. 
83 P_CONF_FILE=/usr/local/etc/privoxy/config
84 # Full path to PID file location. Location must be writable by 
85 # whoever runs this script.
86 P_PIDFILE=/var/run/privoxy.pid
87 # If uncommented, this script will try to run as USER=privoxy, which
88 # may require special handling of config, *.action, trust, logfile, 
89 # jarfile, and pidfile.
90 P_USER=privoxy
91
92 # If a privoxy user is specified, lets try that. /bin/sh does not seem to 
93 # know about $UID.
94 if [ "$USER" = "root" ] && [ -n "$P_USER" ] && id $P_USER >/dev/null; then
95   P_OWNER=$P_USER
96 else 
97   P_OWNER=$USER
98 fi
99
100 if [ ! -f $P_CONF_FILE ]; then
101   echo "Can't find $P_CONF_FILE, exiting."
102   exit 1
103 fi
104
105 case "$1" in
106  
107  start)
108      if [ -f $P_PIDFILE ]; then
109        if kill -0 `cat $P_PIDFILE`; then
110          echo "Error: $P_NAME is already running, exiting."
111          exit 1
112        else
113          rm -f $P_PIDFILE
114        fi
115      fi
116
117         $P_DAEMON --pidfile $P_PIDFILE --user $P_OWNER $P_CONF_FILE 2>/dev/null
118      
119      if [ $? -eq 0 ]; then
120        echo "Starting $P_NAME, OK." 
121      else
122        echo "Starting $P_NAME, Failed."
123        rm -f $P_PIDFILE
124      fi
125      ;;
126  
127  restart)
128      $0 stop
129      $0 start
130      ;;
131  
132  stop)
133      test ! -f $P_PIDFILE && echo "No $P_PIDFILE file found, exiting." && exit 1
134      kill `cat $P_PIDFILE` && rm -f $P_PIDFILE && \
135      echo "Stopping $P_NAME, OK." || echo "Stopping $P_NAME, failed."
136      ;;
137  
138  *)
139      echo "Usage: $0 {start|stop|restart}"
140      exit 1
141      ;;
142
143 esac
144
145 exit 0